/***************************************************************************
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef __CHROMA_H
#define __CHROMA_H

#include "kiss_fft.h"

class chroma {

public:
	double fmin;
	double fmax;
	int bpo;
	int K;
	double Fs;
	int fftlength;

private:
	kiss_fft_cfg cfg;
	kiss_fft_cpx *infft;
	kiss_fft_cpx *outfft;
	double *window;
	double *kernel[2];
	double *kernelfirst;
	double *kernellast;
	double *cqout;

public:
	chroma( double set_fmin, double set_fmax, int set_bpo, double set_Fs );
	~chroma( void );
	void compute( double *in, double *out );
};

#endif
